require File.expand_path('../lvmama-api/error', __FILE__)
require File.expand_path('../lvmama-api/configuration', __FILE__)
require File.expand_path('../lvmama-api/api', __FILE__)
require File.expand_path('../lvmama-api/client', __FILE__)

module Lvmama
  extend Configuration

  # Alias for Lvmama::Client.new
  #
  # @return [Lvmama::Client]
  def self.client(options={})
    Lvmama::Client.new(options)
  end

  # Delegate to Lvmama::Client
  def self.method_missing(method, *args, &block)
    return super unless client.respond_to?(method)
    client.send(method, *args, &block)
  end

  # Delegate to Lvmama::Client
  def self.respond_to?(method, include_all=false)
    return client.respond_to?(method, include_all) || super
  end
end
