module Lvmama
  class Client
    module TicketProd
      ENDPOINT = "distributorApi/2.0/api/ticketProd/".freeze

      def scenic_info_list_by_page current_page, options={}
        options[:currentPage] = current_page
        response = post ENDPOINT + "scenicInfoListByPage", options
        response
      end

      def product_info_list_by_page current_page, options={}
        options[:currentPage] = current_page
        response = post ENDPOINT + "productInfoListByPage", options
        response
      end

      def product_price_list_by_page current_page, begin_date, end_date, options={}
        options[:currentPage] = current_page
        options[:beginDate] = begin_date
        options[:endDate] = end_date
        response = post ENDPOINT + "productPriceListByPage", options
        response
      end

      def product_info_list product_ids, options={}
        options[:productIds] = product_ids
        response = post ENDPOINT + "productInfoList", options
        response
      end

      def good_info_list goods_ids, options={}
        options[:goodsIds] = goods_ids
        response = post ENDPOINT + "goodInfoList", options
        response
      end

      def good_price_list goods_ids, begin_date, end_date, options={}
        options[:goodsIds] = goods_ids
        options[:beginDate] = begin_date
        options[:endDate] = end_date
        response = post ENDPOINT + "goodPriceList", options
        response
      end
    end
  end
end
