require 'digest'

module Lvmama
  # Defines HTTP request methods
  module Request
    # Perform an HTTP GET request
    def get(path, options={}, raw=false)
      request(:get, path, options, raw)
    end

    # Perform an HTTP POST request
    def post(path, options={}, raw=false)
      request(:get, path, options, raw)
    end

    # Perform an HTTP PUT request
    def put(path, options={}, raw=false)
      request(:get, path, options, raw)
    end

    # Perform an HTTP DELETE request
    def delete(path, options={}, raw=false)
      request(:get, path, options, raw)
    end

    private

    # Perform an HTTP request
    def request(method, path, options, raw=false)
      response = connection(raw).send(method) do |request|
        timestamp = Time.now.getutc.to_i
        sign = generate_sign timestamp.to_s, client_secret

        options[:appKey] = client_id
        options[:messageFormat] = format
        options[:timestamp] = timestamp
        options[:sign] = sign

        case method
        when :get, :delete
          request.url(URI.encode(path), options)
        when :post, :put
          request.path = URI.encode(path)
          request.body = options unless options.empty?
        end
      end

      raw ? response : response.body
    end

    def generate_sign timestamp, secret
      sign = secret + timestamp + secret
      md5 = Digest::MD5.new
      md5 << sign
      md5.hexdigest
    end

  end
end

